/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: DemoApplication                                                                                             */
/* Date:  2016-01-13 10:13                                                                                            */

#ifndef __X2C_H__
#define __X2C_H__

/**********************************************************************************************************************/
/**     Includes                                                                                                     **/
/**********************************************************************************************************************/
#include "ManualSwitch_FiP16.h"
#include "Constant_FiP16.h"
#include "AutoSwitch_FiP16.h"
#include "Gain_FiP16.h"
#include "AdaptivePT1_FiP16.h"
#include "Sin3Gen_FiP16.h"
#include "SinGen_FiP16.h"
#include "I_FiP16.h"
#include "Constant_FiP8.h"
#include "Negation_FiP16.h"
#include "Delay_FiP16.h"
#include "Scope_Main.h"
#include "CommonFcts.h"

/**********************************************************************************************************************/
/**     Defines                                                                                                      **/
/**********************************************************************************************************************/
#define FUNCTIONS MANUALSWITCH_FIP16_FUNCTIONS , \
                  CONSTANT_FIP16_FUNCTIONS , \
                  AUTOSWITCH_FIP16_FUNCTIONS , \
                  GAIN_FIP16_FUNCTIONS , \
                  ADAPTIVEPT1_FIP16_FUNCTIONS , \
                  SIN3GEN_FIP16_FUNCTIONS , \
                  SINGEN_FIP16_FUNCTIONS , \
                  I_FIP16_FUNCTIONS , \
                  CONSTANT_FIP8_FUNCTIONS , \
                  NEGATION_FIP16_FUNCTIONS , \
                  DELAY_FIP16_FUNCTIONS , \
                  SCOPE_MAIN_FUNCTIONS 

#define PARAMETER_TABLE { (uint16)1, &TAdaptivePT1 } , \
                        { (uint16)2, &TAmplitude } , \
                        { (uint16)3, &TAutoSwitch } , \
                        { (uint16)4, &TAutoSwitch1 } , \
                        { (uint16)5, &TConstant } , \
                        { (uint16)6, &TFrequency } , \
                        { (uint16)7, &TGain } , \
                        { (uint16)8, &TLED } , \
                        { (uint16)9, &TLED_off } , \
                        { (uint16)10, &TLED_on } , \
                        { (uint16)11, &TManualSwitch } , \
                        { (uint16)12, &TOscillator__AutoSwitch_001 } , \
                        { (uint16)13, &TOscillator__C1_001 } , \
                        { (uint16)14, &TOscillator__C_enable_001 } , \
                        { (uint16)15, &TOscillator__C_init_001 } , \
                        { (uint16)16, &TOscillator__Delay_001 } , \
                        { (uint16)17, &TOscillator__I_001 } , \
                        { (uint16)18, &TOscillator__Negation_001 } , \
                        { (uint16)19, &TSin3Gen } , \
                        { (uint16)20, &TSinGen } , \
                        { (uint16)21, &Tfc } , \
                        { (uint16)22, &TScope } , \
                        { (uint16)23, &Inports.BUTT1 } , \
                        { (uint16)24, &Inports.BUTT2 } , \
                        { (uint16)25, &Inports.VPOT } , \
                        { (uint16)26, &Outports.pLED1 } , \
                        { (uint16)27, &Outports.pLED2 } , \
                        { (uint16)28, &Outports.pLED3 } , \
                        { (uint16)29, &Outports.pLED4 } 

/**********************************************************************************************************************/
/**     Typdefs                                                                                                      **/
/**********************************************************************************************************************/

/* Inport structure                                                                                                   */
typedef struct 
{
    int16 BUTT1;
    int16 VPOT;
    int16 BUTT2;
} TInports;

/* Outport structure                                                                                                  */
typedef struct 
{
    int16* pLED1;
    int16* pLED2;
    int16* pLED3;
    int16* pLED4;
} TOutports;

/**********************************************************************************************************************/
/**     Externals                                                                                                    **/
/**********************************************************************************************************************/
extern TInports Inports;
extern TOutports Outports;
extern const tBlockFunctions blockFunctionTable[];
extern const tParameterTable parameterIdTable[];


/**********************************************************************************************************************/
/**     Prototypes                                                                                                   **/
/**********************************************************************************************************************/
void X2C_Init(void);
void X2C_Update(void);
void X2C_Update_1(void);


#endif
