/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: EP200                                                                                                       */
/* Date:  2016-01-21 12:54                                                                                            */

#include "X2C.h"


/*                                                       Inports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TInports Inports;

/*                                                      Outports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TOutports Outports;

/**********************************************************************************************************************/
/**                                              Global Variables Block                                              **/
/**********************************************************************************************************************/
CONSTANT_FIP16                TDutyCycle;
MANUALSWITCH_FIP8             TManualSwitch;
CONSTANT_FIP8                 TStart;
CONSTANT_FIP8                 TStop;
SCOPE_MAIN                    TScope;

/* Block function table                                                                                               */
#define END_BLOCKFUNCTIONS { (uint16)0, (void (*)(void*))0, (void (*)(void*))0, \
    (uint8 (*)(void*, uint8[]))0, (uint8 (*)(void*, uint8[], uint8))0, (void* (*)(void*, uint16))0 }

const tBlockFunctions blockFunctionTable[] = {
    FUNCTIONS,
    END_BLOCKFUNCTIONS
};

/* Parameter identifier table                                                                                         */
#define END_PARAMETERTABLE { (uint16)0, (void*)0 }

const tParameterTable parameterIdTable[] = {
    PARAMETER_TABLE,
    END_PARAMETERTABLE
};

/**********************************************************************************************************************/
/**                                                  Initialization                                                  **/
/**********************************************************************************************************************/
void X2C_Init()
{
    /******************************************************************************************************************/
    /**                                          Initialize Block Parameters                                         **/
    /******************************************************************************************************************/

    /* Block DutyCycle                                                                                                */
    /* Value = 0.0                                                                                                    */
    TDutyCycle.K = 0;

    /* Block ManualSwitch                                                                                             */
    /* Toggle = 0.0                                                                                                   */
    TManualSwitch.Toggle = 0;

    /* Block Start                                                                                                    */
    /* Value = 1.0                                                                                                    */
    TStart.K = 127;

    /* Block Stop                                                                                                     */
    /* Value = 0.0                                                                                                    */
    TStop.K = 0;


    /******************************************************************************************************************/
    /**                                               Link Block Inputs                                              **/
    /******************************************************************************************************************/

    /* Block DutyCycle                                                                                                */

    /* Block ManualSwitch                                                                                             */
    TManualSwitch.In1                = &TStop.Out;
    TManualSwitch.In2                = &TStart.Out;

    /* Block Start                                                                                                    */

    /* Block Stop                                                                                                     */

    /******************************************************************************************************************/
    /**                                                 Link Outports                                                **/
    /******************************************************************************************************************/
    Outports.pEnablePWM               = &TManualSwitch.Out;
    Outports.pPhase1                  = &TDutyCycle.Out;
    Outports.pPhase2                  = &TDutyCycle.Out;
    Outports.pPhase3                  = &TDutyCycle.Out;

    /******************************************************************************************************************/
    /**                                           Run Block Init Functions                                           **/
    /******************************************************************************************************************/
    Constant_FiP16_Init(&TDutyCycle);
    ManualSwitch_FiP8_Init(&TManualSwitch);
    Constant_FiP8_Init(&TStart);
    Constant_FiP8_Init(&TStop);
    Scope_Main_Init(&TScope);
}

/**********************************************************************************************************************/
/**                                            Run Block Update Functions                                            **/
/**********************************************************************************************************************/

/* X2C_Update for blocks with 1*Ts                                                                                    */
void X2C_Update_1(void)
{
    ManualSwitch_FiP8_Update(&TManualSwitch);
    Scope_Main_Update(&TScope);
}

