/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: EP200                                                                                                       */
/* Date:  2016-01-21 12:54                                                                                            */

#ifndef __X2C_H__
#define __X2C_H__

/**********************************************************************************************************************/
/**     Includes                                                                                                     **/
/**********************************************************************************************************************/
#include "Constant_FiP16.h"
#include "ManualSwitch_FiP8.h"
#include "Constant_FiP8.h"
#include "Scope_Main.h"
#include "CommonFcts.h"

/**********************************************************************************************************************/
/**     Defines                                                                                                      **/
/**********************************************************************************************************************/
#define FUNCTIONS CONSTANT_FIP16_FUNCTIONS , \
                  MANUALSWITCH_FIP8_FUNCTIONS , \
                  CONSTANT_FIP8_FUNCTIONS , \
                  SCOPE_MAIN_FUNCTIONS 

#define PARAMETER_TABLE { (uint16)1, &TDutyCycle } , \
                        { (uint16)2, &TManualSwitch } , \
                        { (uint16)3, &TStart } , \
                        { (uint16)4, &TStop } , \
                        { (uint16)5, &TScope } , \
                        { (uint16)6, &Inports.DigitalIn } , \
                        { (uint16)7, &Inports.Enable } , \
                        { (uint16)8, &Inports.ILimitDriver } , \
                        { (uint16)9, &Inports.I_Phase1 } , \
                        { (uint16)10, &Inports.I_Phase2 } , \
                        { (uint16)11, &Inports.I_Phase3 } , \
                        { (uint16)12, &Inports.SpeedRef } , \
                        { (uint16)13, &Inports.U_DCLink } , \
                        { (uint16)14, &Inports.U_Hall1 } , \
                        { (uint16)15, &Inports.U_Hall2 } , \
                        { (uint16)16, &Inports.ZCDriver } , \
                        { (uint16)17, &Outports.pEnablePWM } , \
                        { (uint16)18, &Outports.pPhase1 } , \
                        { (uint16)19, &Outports.pPhase2 } , \
                        { (uint16)20, &Outports.pPhase3 } 

/**********************************************************************************************************************/
/**     Typdefs                                                                                                      **/
/**********************************************************************************************************************/

/* Inport structure                                                                                                   */
typedef struct 
{
    int16 DigitalIn;
    int8 Enable;
    int16 ILimitDriver;
    int16 I_Phase1;
    int16 I_Phase2;
    int16 I_Phase3;
    int16 SpeedRef;
    int16 U_DCLink;
    int16 U_Hall1;
    int16 U_Hall2;
    int16 ZCDriver;
} TInports;

/* Outport structure                                                                                                  */
typedef struct 
{
    int8* pEnablePWM;
    int16* pPhase1;
    int16* pPhase2;
    int16* pPhase3;
} TOutports;

/**********************************************************************************************************************/
/**     Externals                                                                                                    **/
/**********************************************************************************************************************/
extern TInports Inports;
extern TOutports Outports;
extern const tBlockFunctions blockFunctionTable[];
extern const tParameterTable parameterIdTable[];


/**********************************************************************************************************************/
/**     Prototypes                                                                                                   **/
/**********************************************************************************************************************/
void X2C_Init(void);
void X2C_Update_1(void);


#endif
