/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_closed_loop_pos                                                                                         */
/* Date:  2016-01-22 14:21                                                                                            */

#include "X2C.h"

extern int16 RamTable_int16[512];

extern void initRamTables(void);

/*                                                       Inports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TInports Inports;

/*                                                      Outports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TOutports Outports;

/**********************************************************************************************************************/
/**                                              Global Variables Block                                              **/
/**********************************************************************************************************************/
AVERAGE_FIP16                 TAverage;
AUTOSWITCH_FIP16              TAutoSwitch1;
CONSTANT_FIP16                TConstant2;
GAIN_FIP16                    TSVM__Gain;
GAIN_FIP16                    TSVM__Gain1;
GAIN_FIP16                    TSVM__Gain2;
MAXIMUM_FIP16                 TSVM__Maximum;
MAXIMUM_FIP16                 TSVM__Maximum1;
SUB_FIP16                     TSVM__Sub;
MINIMUM_FIP16                 TSVM__Minimum;
ADD_FIP16                     TSVM__Add;
GAIN_FIP16                    TSVM__Gain3;
SUB_FIP16                     TSVM__Sub1;
SUB_FIP16                     TSVM__Sub2;
MINIMUM_FIP16                 TSVM__Minimum1;
CONSTANT_FIP16                TConstant;
CONSTANT_FIP16                TConstant1;
CONSTANT_FIP16                TConstant3;
AUTOSWITCH_FIP16              TAutoSwitch;
TIMER_INT16                   Ttimer;
RESET_QEI_INT16               Treset_qei;
TYPECONV_FIP16_8              TTypeConv;
CONSTANT_FIP16                TConstant5;
NEGATION_FIP16                TNegation1;
PARK_INV_INT16_ASM            Tpark_inv;
CLARK_INV_INT16_ASM           Tclark_inv;
CONSTANT_FIP16                TConstant6;
NEGATION_FIP16                TNegation2;
CLARK_INT16_ASM               Tclark;
PARK_INT16_ASM                Tpark;
PI_FIP16                      TPI1;
PI_FIP16                      TPI2;
CONSTANT_FIP16                TConstant7;
SUB_FIP16                     TSub1;
PI_FIP16                      TPI3;
SUB_FIP16                     TSub2;
PI_FIP16                      TPI4;
SUB_FIP16                     TSub3;
SUB_FIP16                     TSub4;
AVERAGE_FIP16                 TAverage1;
SCOPE_MAIN                    TScope;

/* Block function table                                                                                               */
#define END_BLOCKFUNCTIONS { (uint16)0, (void (*)(void*))0, (void (*)(void*))0, \
    (uint8 (*)(void*, uint8[]))0, (uint8 (*)(void*, uint8[], uint8))0, (void* (*)(void*, uint16))0 }

const tBlockFunctions blockFunctionTable[] = {
    FUNCTIONS,
    END_BLOCKFUNCTIONS
};

/* Parameter identifier table                                                                                         */
#define END_PARAMETERTABLE { (uint16)0, (void*)0 }

const tParameterTable parameterIdTable[] = {
    PARAMETER_TABLE,
    END_PARAMETERTABLE
};

/**********************************************************************************************************************/
/**                                                  Initialization                                                  **/
/**********************************************************************************************************************/
void X2C_Init()
{
    /******************************************************************************************************************/
    /**                                          Initialize Block Parameters                                         **/
    /******************************************************************************************************************/

    /* Block Average                                                                                                  */
    /* n = 256                                                                                                        */
    /* ts_fact = 1.0                                                                                                  */
    TAverage.n = 256;
    TAverage.sfrn = 8;
    TAverage.sum = 0;
    TAverage.count = 0;
    TAverage.avg = &RamTable_int16[0];

    /* Block AutoSwitch1                                                                                              */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch1.Thresh_up = 16384;
    TAutoSwitch1.Thresh_down = 0;
    TAutoSwitch1.Status = 0;

    /* Block Constant2                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant2.K = 0;

    /* Block SVM__Gain                                                                                                */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain.V = -18022;
    TSVM__Gain.sfr = 14;

    /* Block SVM__Gain1                                                                                               */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain1.V = -18022;
    TSVM__Gain1.sfr = 14;

    /* Block SVM__Gain2                                                                                               */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain2.V = -18022;
    TSVM__Gain2.sfr = 14;

    /* Block SVM__Maximum                                                                                             */

    /* Block SVM__Maximum1                                                                                            */

    /* Block SVM__Sub                                                                                                 */

    /* Block SVM__Minimum                                                                                             */

    /* Block SVM__Add                                                                                                 */

    /* Block SVM__Gain3                                                                                               */
    /* Gain = 0.5                                                                                                     */
    TSVM__Gain3.V = 16384;
    TSVM__Gain3.sfr = 15;

    /* Block SVM__Sub1                                                                                                */

    /* Block SVM__Sub2                                                                                                */

    /* Block SVM__Minimum1                                                                                            */

    /* Block Constant                                                                                                 */
    /* Value = 0.6                                                                                                    */
    TConstant.K = 19661;

    /* Block Constant1                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant1.K = 0;

    /* Block Constant3                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant3.K = 0;

    /* Block AutoSwitch                                                                                               */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch.Thresh_up = 16384;
    TAutoSwitch.Thresh_down = 0;
    TAutoSwitch.Status = 0;

    /* Block timer                                                                                                    */
    /* ts_fact = 1.0                                                                                                  */
    /* time = 1.0                                                                                                     */
    Ttimer.cnt_val = 0;
    Ttimer.cnt_lim = 20000;

    /* Block reset_qei                                                                                                */
    Treset_qei.is_reseted = 0;

    /* Block TypeConv                                                                                                 */

    /* Block Constant5                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant5.K = 0;

    /* Block Negation1                                                                                                */

    /* Block park_inv                                                                                                 */

    /* Block clark_inv                                                                                                */

    /* Block Constant6                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant6.K = 0;

    /* Block Negation2                                                                                                */

    /* Block clark                                                                                                    */

    /* Block park                                                                                                     */

    /* Block PI1                                                                                                      */
    /* Kp = 4.0                                                                                                       */
    /* Ki = 1.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    TPI1.b0 = 2;
    TPI1.b1 = 16384;
    TPI1.sfrb0 = 15;
    TPI1.sfrb1 = 12;
    TPI1.i_old = 0;
    TPI1.enable_old = 0;

    /* Block PI2                                                                                                      */
    /* Kp = 0.8                                                                                                       */
    /* Ki = 1.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    TPI2.b0 = 2;
    TPI2.b1 = 26214;
    TPI2.sfrb0 = 15;
    TPI2.sfrb1 = 15;
    TPI2.i_old = 0;
    TPI2.enable_old = 0;

    /* Block Constant7                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant7.K = 0;

    /* Block Sub1                                                                                                     */

    /* Block PI3                                                                                                      */
    /* Kp = 5.0                                                                                                       */
    /* Ki = 5.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    TPI3.b0 = 8;
    TPI3.b1 = 20480;
    TPI3.sfrb0 = 15;
    TPI3.sfrb1 = 12;
    TPI3.i_old = 0;
    TPI3.enable_old = 0;

    /* Block Sub2                                                                                                     */

    /* Block PI4                                                                                                      */
    /* Kp = 0.8                                                                                                       */
    /* Ki = 0.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    TPI4.b0 = 0;
    TPI4.b1 = 26214;
    TPI4.sfrb0 = 15;
    TPI4.sfrb1 = 15;
    TPI4.i_old = 0;
    TPI4.enable_old = 0;

    /* Block Sub3                                                                                                     */

    /* Block Sub4                                                                                                     */

    /* Block Average1                                                                                                 */
    /* n = 256                                                                                                        */
    /* ts_fact = 1.0                                                                                                  */
    TAverage1.n = 256;
    TAverage1.sfrn = 8;
    TAverage1.sum = 0;
    TAverage1.count = 0;
    TAverage1.avg = &RamTable_int16[256];


    /* Initialize RAM table content */
    initRamTables();

    /******************************************************************************************************************/
    /**                                               Link Block Inputs                                              **/
    /******************************************************************************************************************/

    /* Block Average                                                                                                  */
    TAverage.In                      = &TAverage1.Out;

    /* Block AutoSwitch1                                                                                              */
    TAutoSwitch1.In1                 = &Tpark_inv.alpha;
    TAutoSwitch1.Switch              = &Ttimer.out;
    TAutoSwitch1.In3                 = &TConstant.Out;

    /* Block Constant2                                                                                                */

    /* Block SVM__Gain                                                                                                */
    TSVM__Gain.In                    = &TSVM__Sub.Out;

    /* Block SVM__Gain1                                                                                               */
    TSVM__Gain1.In                   = &TSVM__Sub2.Out;

    /* Block SVM__Gain2                                                                                               */
    TSVM__Gain2.In                   = &TSVM__Sub1.Out;

    /* Block SVM__Maximum                                                                                             */
    TSVM__Maximum.In1                = &TSVM__Maximum1.Out;
    TSVM__Maximum.In2                = &Tclark_inv.c;

    /* Block SVM__Maximum1                                                                                            */
    TSVM__Maximum1.In1               = &Tclark_inv.a;
    TSVM__Maximum1.In2               = &Tclark_inv.b;

    /* Block SVM__Sub                                                                                                 */
    TSVM__Sub.Plus                   = &Tclark_inv.a;
    TSVM__Sub.Minus                  = &TSVM__Gain3.Out;

    /* Block SVM__Minimum                                                                                             */
    TSVM__Minimum.In1                = &Tclark_inv.a;
    TSVM__Minimum.In2                = &Tclark_inv.b;

    /* Block SVM__Add                                                                                                 */
    TSVM__Add.In1                    = &TSVM__Maximum.Out;
    TSVM__Add.In2                    = &TSVM__Minimum1.Out;

    /* Block SVM__Gain3                                                                                               */
    TSVM__Gain3.In                   = &TSVM__Add.Out;

    /* Block SVM__Sub1                                                                                                */
    TSVM__Sub1.Plus                  = &Tclark_inv.b;
    TSVM__Sub1.Minus                 = &TSVM__Gain3.Out;

    /* Block SVM__Sub2                                                                                                */
    TSVM__Sub2.Plus                  = &Tclark_inv.c;
    TSVM__Sub2.Minus                 = &TSVM__Gain3.Out;

    /* Block SVM__Minimum1                                                                                            */
    TSVM__Minimum1.In1               = &TSVM__Minimum.Out;
    TSVM__Minimum1.In2               = &Tclark_inv.c;

    /* Block Constant                                                                                                 */

    /* Block Constant1                                                                                                */

    /* Block Constant3                                                                                                */

    /* Block AutoSwitch                                                                                               */
    TAutoSwitch.In1                  = &Tpark_inv.beta;
    TAutoSwitch.Switch               = &Ttimer.out;
    TAutoSwitch.In3                  = &TConstant1.Out;

    /* Block timer                                                                                                    */

    /* Block reset_qei                                                                                                */
    Treset_qei.enable                = &Ttimer.out;

    /* Block TypeConv                                                                                                 */
    TTypeConv.In                     = &Ttimer.out;

    /* Block Constant5                                                                                                */

    /* Block Negation1                                                                                                */
    TNegation1.In                    = &Tpark.q;

    /* Block park_inv                                                                                                 */
    Tpark_inv.d                      = &TPI2.Out;
    Tpark_inv.q                      = &TPI4.Out;
    Tpark_inv.theta                  = &(Inports.qei);

    /* Block clark_inv                                                                                                */
    Tclark_inv.alpha                 = &TAutoSwitch1.Out;
    Tclark_inv.beta                  = &TAutoSwitch.Out;

    /* Block Constant6                                                                                                */

    /* Block Negation2                                                                                                */
    TNegation2.In                    = &(Inports.qei);

    /* Block clark                                                                                                    */
    Tclark.a                         = &(Inports.i_a);
    Tclark.b                         = &(Inports.i_b);

    /* Block park                                                                                                     */
    Tpark.alpha                      = &Tclark.alpha;
    Tpark.beta                       = &Tclark.beta;
    Tpark.theta                      = &TNegation2.Out;

    /* Block PI1                                                                                                      */
    TPI1.In                          = &TSub2.Out;
    TPI1.Init                        = &TConstant3.Out;
    TPI1.Enable                      = &TTypeConv.Out;

    /* Block PI2                                                                                                      */
    TPI2.In                          = &TSub4.Out;
    TPI2.Init                        = &TConstant2.Out;
    TPI2.Enable                      = &TTypeConv.Out;

    /* Block Constant7                                                                                                */

    /* Block Sub1                                                                                                     */
    TSub1.Plus                       = &TAverage.Out;
    TSub1.Minus                      = &(Inports.pos_meas);

    /* Block PI3                                                                                                      */
    TPI3.In                          = &TSub1.Out;
    TPI3.Init                        = &TConstant7.Out;
    TPI3.Enable                      = &TTypeConv.Out;

    /* Block Sub2                                                                                                     */
    TSub2.Plus                       = &TPI3.Out;
    TSub2.Minus                      = &(Inports.omega_meas);

    /* Block PI4                                                                                                      */
    TPI4.In                          = &TSub3.Out;
    TPI4.Init                        = &TConstant6.Out;
    TPI4.Enable                      = &TTypeConv.Out;

    /* Block Sub3                                                                                                     */
    TSub3.Plus                       = &TPI1.Out;
    TSub3.Minus                      = &TNegation1.Out;

    /* Block Sub4                                                                                                     */
    TSub4.Plus                       = &TConstant5.Out;
    TSub4.Minus                      = &Tpark.d;

    /* Block Average1                                                                                                 */
    TAverage1.In                     = &(Inports.pos_set);

    /******************************************************************************************************************/
    /**                                                 Link Outports                                                **/
    /******************************************************************************************************************/
    Outports.pPWM1                    = &TSVM__Gain.Out;
    Outports.pPWM2                    = &TSVM__Gain2.Out;
    Outports.pPWM3                    = &TSVM__Gain1.Out;

    /******************************************************************************************************************/
    /**                                           Run Block Init Functions                                           **/
    /******************************************************************************************************************/
    Average_FiP16_Init(&TAverage);
    AutoSwitch_FiP16_Init(&TAutoSwitch1);
    Constant_FiP16_Init(&TConstant2);
    Gain_FiP16_Init(&TSVM__Gain);
    Gain_FiP16_Init(&TSVM__Gain1);
    Gain_FiP16_Init(&TSVM__Gain2);
    Maximum_FiP16_Init(&TSVM__Maximum);
    Maximum_FiP16_Init(&TSVM__Maximum1);
    Sub_FiP16_Init(&TSVM__Sub);
    Minimum_FiP16_Init(&TSVM__Minimum);
    Add_FiP16_Init(&TSVM__Add);
    Gain_FiP16_Init(&TSVM__Gain3);
    Sub_FiP16_Init(&TSVM__Sub1);
    Sub_FiP16_Init(&TSVM__Sub2);
    Minimum_FiP16_Init(&TSVM__Minimum1);
    Constant_FiP16_Init(&TConstant);
    Constant_FiP16_Init(&TConstant1);
    Constant_FiP16_Init(&TConstant3);
    AutoSwitch_FiP16_Init(&TAutoSwitch);
    timer_INT16_Init(&Ttimer);
    reset_qei_INT16_Init(&Treset_qei);
    TypeConv_FiP16_8_Init(&TTypeConv);
    Constant_FiP16_Init(&TConstant5);
    Negation_FiP16_Init(&TNegation1);
    park_inv_INT16_ASM_Init(&Tpark_inv);
    clark_inv_INT16_ASM_Init(&Tclark_inv);
    Constant_FiP16_Init(&TConstant6);
    Negation_FiP16_Init(&TNegation2);
    clark_INT16_ASM_Init(&Tclark);
    park_INT16_ASM_Init(&Tpark);
    PI_FiP16_Init(&TPI1);
    PI_FiP16_Init(&TPI2);
    Constant_FiP16_Init(&TConstant7);
    Sub_FiP16_Init(&TSub1);
    PI_FiP16_Init(&TPI3);
    Sub_FiP16_Init(&TSub2);
    PI_FiP16_Init(&TPI4);
    Sub_FiP16_Init(&TSub3);
    Sub_FiP16_Init(&TSub4);
    Average_FiP16_Init(&TAverage1);
    Scope_Main_Init(&TScope);
}

/**********************************************************************************************************************/
/**                                            Run Block Update Functions                                            **/
/**********************************************************************************************************************/
void X2C_Update(void)
{
    X2C_Update_1();

}

/* X2C_Update for blocks with 1*Ts                                                                                    */
void X2C_Update_1(void)
{
    Average_FiP16_Update(&TAverage1);
    Average_FiP16_Update(&TAverage);
    Sub_FiP16_Update(&TSub1);
    Negation_FiP16_Update(&TNegation2);
    clark_INT16_ASM_Update(&Tclark);
    park_INT16_ASM_Update(&Tpark);
    timer_INT16_Update(&Ttimer);
    Negation_FiP16_Update(&TNegation1);
    Sub_FiP16_Update(&TSub4);
    TypeConv_FiP16_8_Update(&TTypeConv);
    PI_FiP16_Update(&TPI2);
    PI_FiP16_Update(&TPI3);
    Sub_FiP16_Update(&TSub2);
    PI_FiP16_Update(&TPI1);
    Sub_FiP16_Update(&TSub3);
    PI_FiP16_Update(&TPI4);
    park_inv_INT16_ASM_Update(&Tpark_inv);
    AutoSwitch_FiP16_Update(&TAutoSwitch);
    AutoSwitch_FiP16_Update(&TAutoSwitch1);
    reset_qei_INT16_Update(&Treset_qei);
    clark_inv_INT16_ASM_Update(&Tclark_inv);
    Maximum_FiP16_Update(&TSVM__Maximum1);
    Minimum_FiP16_Update(&TSVM__Minimum);
    Maximum_FiP16_Update(&TSVM__Maximum);
    Minimum_FiP16_Update(&TSVM__Minimum1);
    Add_FiP16_Update(&TSVM__Add);
    Gain_FiP16_Update(&TSVM__Gain3);
    Sub_FiP16_Update(&TSVM__Sub);
    Sub_FiP16_Update(&TSVM__Sub1);
    Sub_FiP16_Update(&TSVM__Sub2);
    Gain_FiP16_Update(&TSVM__Gain);
    Gain_FiP16_Update(&TSVM__Gain1);
    Gain_FiP16_Update(&TSVM__Gain2);
    Scope_Main_Update(&TScope);
}

