/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_closed_loop_pos                                                                                         */
/* Date:  2016-01-22 14:21                                                                                            */

#ifndef __X2C_H__
#define __X2C_H__

/**********************************************************************************************************************/
/**     Includes                                                                                                     **/
/**********************************************************************************************************************/
#include "Average_FiP16.h"
#include "AutoSwitch_FiP16.h"
#include "Constant_FiP16.h"
#include "Gain_FiP16.h"
#include "Maximum_FiP16.h"
#include "Sub_FiP16.h"
#include "Minimum_FiP16.h"
#include "Add_FiP16.h"
#include "timer_INT16.h"
#include "reset_qei_INT16.h"
#include "TypeConv_FiP16_8.h"
#include "Negation_FiP16.h"
#include "park_inv_INT16_ASM.h"
#include "clark_inv_INT16_ASM.h"
#include "clark_INT16_ASM.h"
#include "park_INT16_ASM.h"
#include "PI_FiP16.h"
#include "Scope_Main.h"
#include "CommonFcts.h"

/**********************************************************************************************************************/
/**     Defines                                                                                                      **/
/**********************************************************************************************************************/
#define FUNCTIONS AVERAGE_FIP16_FUNCTIONS , \
                  AUTOSWITCH_FIP16_FUNCTIONS , \
                  CONSTANT_FIP16_FUNCTIONS , \
                  GAIN_FIP16_FUNCTIONS , \
                  MAXIMUM_FIP16_FUNCTIONS , \
                  SUB_FIP16_FUNCTIONS , \
                  MINIMUM_FIP16_FUNCTIONS , \
                  ADD_FIP16_FUNCTIONS , \
                  TIMER_INT16_FUNCTIONS , \
                  RESET_QEI_INT16_FUNCTIONS , \
                  TYPECONV_FIP16_8_FUNCTIONS , \
                  NEGATION_FIP16_FUNCTIONS , \
                  PARK_INV_INT16_ASM_FUNCTIONS , \
                  CLARK_INV_INT16_ASM_FUNCTIONS , \
                  CLARK_INT16_ASM_FUNCTIONS , \
                  PARK_INT16_ASM_FUNCTIONS , \
                  PI_FIP16_FUNCTIONS , \
                  SCOPE_MAIN_FUNCTIONS 

#define PARAMETER_TABLE { (uint16)1, &TAutoSwitch } , \
                        { (uint16)2, &TAutoSwitch1 } , \
                        { (uint16)3, &TAverage } , \
                        { (uint16)4, &TAverage1 } , \
                        { (uint16)5, &TConstant } , \
                        { (uint16)6, &TConstant1 } , \
                        { (uint16)7, &TConstant2 } , \
                        { (uint16)8, &TConstant3 } , \
                        { (uint16)9, &TConstant5 } , \
                        { (uint16)10, &TConstant6 } , \
                        { (uint16)11, &TConstant7 } , \
                        { (uint16)12, &TNegation1 } , \
                        { (uint16)13, &TNegation2 } , \
                        { (uint16)14, &TPI1 } , \
                        { (uint16)15, &TPI2 } , \
                        { (uint16)16, &TPI3 } , \
                        { (uint16)17, &TPI4 } , \
                        { (uint16)18, &TSVM__Add } , \
                        { (uint16)19, &TSVM__Gain } , \
                        { (uint16)20, &TSVM__Gain1 } , \
                        { (uint16)21, &TSVM__Gain2 } , \
                        { (uint16)22, &TSVM__Gain3 } , \
                        { (uint16)23, &TSVM__Maximum } , \
                        { (uint16)24, &TSVM__Maximum1 } , \
                        { (uint16)25, &TSVM__Minimum } , \
                        { (uint16)26, &TSVM__Minimum1 } , \
                        { (uint16)27, &TSVM__Sub } , \
                        { (uint16)28, &TSVM__Sub1 } , \
                        { (uint16)29, &TSVM__Sub2 } , \
                        { (uint16)30, &TSub1 } , \
                        { (uint16)31, &TSub2 } , \
                        { (uint16)32, &TSub3 } , \
                        { (uint16)33, &TSub4 } , \
                        { (uint16)34, &TTypeConv } , \
                        { (uint16)35, &Tclark } , \
                        { (uint16)36, &Tclark_inv } , \
                        { (uint16)37, &Tpark } , \
                        { (uint16)38, &Tpark_inv } , \
                        { (uint16)39, &Treset_qei } , \
                        { (uint16)40, &Ttimer } , \
                        { (uint16)41, &TScope } , \
                        { (uint16)42, &Inports.i_a } , \
                        { (uint16)43, &Inports.i_b } , \
                        { (uint16)44, &Inports.omega_meas } , \
                        { (uint16)45, &Inports.pos_meas } , \
                        { (uint16)46, &Inports.pos_set } , \
                        { (uint16)47, &Inports.qei } , \
                        { (uint16)48, &Outports.pPWM1 } , \
                        { (uint16)49, &Outports.pPWM2 } , \
                        { (uint16)50, &Outports.pPWM3 } 

/**********************************************************************************************************************/
/**     Typdefs                                                                                                      **/
/**********************************************************************************************************************/

/* Inport structure                                                                                                   */
typedef struct 
{
    int16 omega_meas;
    int16 i_a;
    int16 i_b;
    int16 pos_meas;
    int16 qei;
    int16 pos_set;
} TInports;

/* Outport structure                                                                                                  */
typedef struct 
{
    int16* pPWM1;
    int16* pPWM2;
    int16* pPWM3;
} TOutports;

/**********************************************************************************************************************/
/**     Externals                                                                                                    **/
/**********************************************************************************************************************/
extern TInports Inports;
extern TOutports Outports;
extern const tBlockFunctions blockFunctionTable[];
extern const tParameterTable parameterIdTable[];


/**********************************************************************************************************************/
/**     Prototypes                                                                                                   **/
/**********************************************************************************************************************/
void X2C_Init(void);
void X2C_Update(void);
void X2C_Update_1(void);


#endif
