/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_open_loop_v3                                                                                            */
/* Date:  2016-01-14 17:02                                                                                            */

#ifndef __X2C_H__
#define __X2C_H__

/**********************************************************************************************************************/
/**     Includes                                                                                                     **/
/**********************************************************************************************************************/
#include "Constant_FiP16.h"
#include "AutoSwitch_FiP16.h"
#include "timer_INT16.h"
#include "clark_INT16_ASM.h"
#include "park_INT16_ASM.h"
#include "reset_qei_INT16.h"
#include "park_inv_INT16_ASM.h"
#include "clark_inv_INT16_ASM.h"
#include "Negation_FiP16.h"
#include "Maximum_FiP16.h"
#include "Gain_FiP16.h"
#include "Add_FiP16.h"
#include "Minimum_FiP16.h"
#include "Sub_FiP16.h"
#include "Scope_Main.h"
#include "CommonFcts.h"

/**********************************************************************************************************************/
/**     Defines                                                                                                      **/
/**********************************************************************************************************************/
#define FUNCTIONS CONSTANT_FIP16_FUNCTIONS , \
                  AUTOSWITCH_FIP16_FUNCTIONS , \
                  TIMER_INT16_FUNCTIONS , \
                  CLARK_INT16_ASM_FUNCTIONS , \
                  PARK_INT16_ASM_FUNCTIONS , \
                  RESET_QEI_INT16_FUNCTIONS , \
                  PARK_INV_INT16_ASM_FUNCTIONS , \
                  CLARK_INV_INT16_ASM_FUNCTIONS , \
                  NEGATION_FIP16_FUNCTIONS , \
                  MAXIMUM_FIP16_FUNCTIONS , \
                  GAIN_FIP16_FUNCTIONS , \
                  ADD_FIP16_FUNCTIONS , \
                  MINIMUM_FIP16_FUNCTIONS , \
                  SUB_FIP16_FUNCTIONS , \
                  SCOPE_MAIN_FUNCTIONS 

#define PARAMETER_TABLE { (uint16)1, &TAutoSwitch } , \
                        { (uint16)2, &TAutoSwitch1 } , \
                        { (uint16)3, &TConstant } , \
                        { (uint16)4, &TConstant1 } , \
                        { (uint16)5, &TConstant5 } , \
                        { (uint16)6, &TConstant6 } , \
                        { (uint16)7, &TNegation } , \
                        { (uint16)8, &TSVM__Add } , \
                        { (uint16)9, &TSVM__Gain } , \
                        { (uint16)10, &TSVM__Gain1 } , \
                        { (uint16)11, &TSVM__Gain2 } , \
                        { (uint16)12, &TSVM__Gain3 } , \
                        { (uint16)13, &TSVM__Maximum } , \
                        { (uint16)14, &TSVM__Maximum1 } , \
                        { (uint16)15, &TSVM__Minimum } , \
                        { (uint16)16, &TSVM__Minimum1 } , \
                        { (uint16)17, &TSVM__Sub } , \
                        { (uint16)18, &TSVM__Sub1 } , \
                        { (uint16)19, &TSVM__Sub2 } , \
                        { (uint16)20, &Tclark } , \
                        { (uint16)21, &Tclark_inv } , \
                        { (uint16)22, &Tpark } , \
                        { (uint16)23, &Tpark_inv } , \
                        { (uint16)24, &Treset_qei } , \
                        { (uint16)25, &Ttimer } , \
                        { (uint16)26, &TScope } , \
                        { (uint16)27, &Inports.Inport } , \
                        { (uint16)28, &Inports.i_a } , \
                        { (uint16)29, &Inports.i_b } , \
                        { (uint16)30, &Outports.pOutport } , \
                        { (uint16)31, &Outports.pOutport1 } , \
                        { (uint16)32, &Outports.pdebug_i_alpha } , \
                        { (uint16)33, &Outports.pOutport2 } , \
                        { (uint16)34, &Outports.pdebug_i_beta } , \
                        { (uint16)35, &Outports.pdebug_id } , \
                        { (uint16)36, &Outports.pdebug_iq } 

/**********************************************************************************************************************/
/**     Typdefs                                                                                                      **/
/**********************************************************************************************************************/

/* Inport structure                                                                                                   */
typedef struct 
{
    int16 Inport;
    int16 i_a;
    int16 i_b;
} TInports;

/* Outport structure                                                                                                  */
typedef struct 
{
    int16* pOutport;
    int16* pOutport1;
    int16* pdebug_i_alpha;
    int16* pOutport2;
    int16* pdebug_i_beta;
    int16* pdebug_id;
    int16* pdebug_iq;
} TOutports;

/**********************************************************************************************************************/
/**     Externals                                                                                                    **/
/**********************************************************************************************************************/
extern TInports Inports;
extern TOutports Outports;
extern const tBlockFunctions blockFunctionTable[];
extern const tParameterTable parameterIdTable[];


/**********************************************************************************************************************/
/**     Prototypes                                                                                                   **/
/**********************************************************************************************************************/
void X2C_Init(void);
void X2C_Update(void);
void X2C_Update_1(void);


#endif
