/*
 * Copyright (c) {YEAR}, {ORGANIZATION_NAME}, {ORGANIZATION_WEB}
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the "{ORGANIZATION_NAME}" nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "{ORGANIZATION_NAME}" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. http://www.mechatronic-simulation.org/
 * $LastChangedRevision$
 */
/* USERCODE-BEGIN:Description                                                                                         */
/* Description: */
/* USERCODE-END:Description                                                                                           */
#ifndef __TIMER_INT16__
#define __TIMER_INT16__

#include "CommonFcts.h"

#if !defined(TIMER_INT16_ISLINKED)
#define TIMER_INT16_ID      ((uint16)20816)

typedef struct {
        uint16       ID;
        int16        out;
        int16        cnt_val;
        int16        cnt_lim;
} TIMER_INT16;

#define TIMER_INT16_FUNCTIONS {TIMER_INT16_ID, \
                              (void (*)(void*))timer_INT16_Update, \
                              (void (*)(void*))timer_INT16_Init, \
                              (uint8 (*)(void*, uint8[]))timer_INT16_Load, \
                              (uint8 (*)(void*, uint8[], uint8))timer_INT16_Save, \
                              (void* (*)(void*, uint16))timer_INT16_GetAddress}

/**********************************************************************************************************************/
/** Public prototypes                                                                                                **/
/**********************************************************************************************************************/
void timer_INT16_Update(TIMER_INT16 *pTtimer_INT16);
void timer_INT16_Init(TIMER_INT16 *pTtimer_INT16);
uint8 timer_INT16_Load(const TIMER_INT16 *pTtimer_INT16, uint8 data[]);
uint8 timer_INT16_Save(TIMER_INT16 *pTtimer_INT16, const uint8 data[], uint8 frameLength);
void* timer_INT16_GetAddress(const TIMER_INT16* block, uint16 elementId);

#endif

#endif
