/*
 * Copyright (c) {YEAR}, {ORGANIZATION_NAME}, {ORGANIZATION_WEB}
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the "{ORGANIZATION_NAME}" nor
 *     the names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "{ORGANIZATION_NAME}" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. http://www.mechatronic-simulation.org/
 * $LastChangedRevision$
 */
// USERCODE-BEGIN:Description                                                                                           
/* Description: */
// USERCODE-END:Description                                                                                             

package at.lcm.x2c.library.mchp;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

// USERCODE-BEGIN:Imports                                                                                               
// USERCODE-END:Imports                                                                                                 

@SuppressWarnings("unused")
public class ConvFnc_sawtooth_INT16 extends ConversionFunction {
     private static final long serialVersionUID = 1L;

     public ConvFnc_sawtooth_INT16() throws Exception {
     }

     public void convert() throws Exception {

          MaskDouble ts_factMaskVal = 
               (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
          TNumeric ts_factMaskData = 
               (TNumeric)ts_factMaskVal.getData();
          MaskDouble timeMaskVal = 
               (MaskDouble)this.getMaskParameter("time").getMaskDataType();
          TNumeric timeMaskData = 
               (TNumeric)timeMaskVal.getData();

          // Controller Parameter Data                                                                                  
          TNumeric time_ctrCtrVal = this.getCtrlParamData("time_ctr");
          TNumeric cnt_dirCtrVal = this.getCtrlParamData("cnt_dir");
          TNumeric addCtrVal = this.getCtrlParamData("add");
          TNumeric cnt_valCtrVal = this.getCtrlParamData("cnt_val");

// USERCODE-BEGIN:ConvFnc                                                                                               
		double Ts = 0;
		double timeMask;
		double ctr;
		double add;
		int ts_fact;

		timeMask = Double.valueOf(timeMaskVal.getValue());
		ts_fact = Double.valueOf(ts_factMaskVal.getValue()).intValue();
		// validate controller parameters
		if (ts_fact <= 0) {
			ts_fact = 1;
		}

		Ts = ts_fact * this.getDedicatedBlock().getModel().getSampleTime();

		// calculate Ctr value:

		ctr = timeMask / Ts;
		add = 32768 / ctr;

		time_ctrCtrVal.setReal(0, 0, Double.valueOf(ctr).intValue());
		addCtrVal.setReal(0, 0, Double.valueOf(add).intValue());
// USERCODE-END:ConvFnc                                                                                                 
          this.setCtrlParamData("time_ctr", time_ctrCtrVal);
          this.setCtrlParamData("cnt_dir", cnt_dirCtrVal);
          this.setCtrlParamData("add", addCtrVal);
          this.setCtrlParamData("cnt_val", cnt_valCtrVal);
     }

     public void revert() throws Exception {

          MaskDouble ts_factMaskVal = 
               (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
          TNumeric ts_factMaskData = 
               (TNumeric)ts_factMaskVal.getData();
          MaskDouble timeMaskVal = 
               (MaskDouble)this.getMaskParameter("time").getMaskDataType();
          TNumeric timeMaskData = 
               (TNumeric)timeMaskVal.getData();

          // Controller Parameter Data                                                                                  
          TNumeric time_ctrCtrVal = this.getCtrlParamData("time_ctr");
          TNumeric cnt_dirCtrVal = this.getCtrlParamData("cnt_dir");
          TNumeric addCtrVal = this.getCtrlParamData("add");
          TNumeric cnt_valCtrVal = this.getCtrlParamData("cnt_val");

// USERCODE-BEGIN:RevFnc                                                                                                
		/* Insert parameter reversion here... */
// USERCODE-END:RevFnc                                                                                                  
          this.getMaskParameter("ts_fact").setValue(ts_factMaskData.toFullString());
          this.getMaskParameter("time").setValue(timeMaskData.toFullString());
     }
}
