// This file was generated by createCFunction.sci on 26-01-2016 11:59

// Computational function for X2C block clark_inv

#define SCILAB_SIM_FILE /* mark this file as Scilab simulation file */

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
#include <Simulation_PortConversion.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <clark_inv_INT16_ASM.h>
#include <clark_inv_INT16_ASM.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_clark_inv_INT16_ASM_C(scicos_block* block, scicos_flag flag);
static void x2c_clark_inv_INT16_ASM_C__OutputUpdate(scicos_block* block);
static void x2c_clark_inv_INT16_ASM_C__StateUpdate(scicos_block* block);
static void x2c_clark_inv_INT16_ASM_C__Initialization(scicos_block* block);
static void x2c_clark_inv_INT16_ASM_C__Ending(scicos_block* block);


void x2c_clark_inv_INT16_ASM_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_clark_inv_INT16_ASM_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_clark_inv_INT16_ASM_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_clark_inv_INT16_ASM_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_clark_inv_INT16_ASM_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_clark_inv_INT16_ASM_C__set_parameter(scicos_block* block, CLARK_INV_INT16_ASM *blockParam) {
    int *paramI;
    double *paramR;
    CLARK_INV_INT16_ASM *pTclark_inv_INT16_ASM;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTclark_inv_INT16_ASM = GetWorkPtrs(block);
}


static void x2c_clark_inv_INT16_ASM_C__Initialization(scicos_block* block) {
    CLARK_INV_INT16_ASM *pTclark_inv_INT16_ASM;

    /* Declaration of inports */
    double *inport_alpha_p;
    int16 inport_alpha;
    double *inport_beta_p;
    int16 inport_beta;

    /* Declaration of outports */
    double *outport_a;
    double *outport_b;
    double *outport_c;

    /* *** */
    pTclark_inv_INT16_ASM = scicos_malloc(sizeof(CLARK_INV_INT16_ASM));
    GetWorkPtrs(block) = pTclark_inv_INT16_ASM;
    x2c_clark_inv_INT16_ASM_C__set_parameter(block, pTclark_inv_INT16_ASM);

    /* Assignment of inports */
    inport_alpha_p = GetInPortPtrs(block, 1);
    inport_alpha = convert_double_to_Q15(*inport_alpha_p);
    pTclark_inv_INT16_ASM->alpha = &inport_alpha;
    inport_beta_p = GetInPortPtrs(block, 2);
    inport_beta = convert_double_to_Q15(*inport_beta_p);
    pTclark_inv_INT16_ASM->beta = &inport_beta;

    /* Initialization */
    clark_inv_INT16_ASM_Init(pTclark_inv_INT16_ASM);

    /* Assignment of outports */
    outport_a = GetOutPortPtrs(block, 1);
    *outport_a = convert_Q15_to_double(pTclark_inv_INT16_ASM->a);
    outport_b = GetOutPortPtrs(block, 2);
    *outport_b = convert_Q15_to_double(pTclark_inv_INT16_ASM->b);
    outport_c = GetOutPortPtrs(block, 3);
    *outport_c = convert_Q15_to_double(pTclark_inv_INT16_ASM->c);
}


static void x2c_clark_inv_INT16_ASM_C__Ending(scicos_block* block) {
    CLARK_INV_INT16_ASM *pTclark_inv_INT16_ASM;
    pTclark_inv_INT16_ASM = GetWorkPtrs(block);
    scicos_free(pTclark_inv_INT16_ASM);
}


static void x2c_clark_inv_INT16_ASM_C__StateUpdate_f(scicos_block* block) {
    CLARK_INV_INT16_ASM *pTclark_inv_INT16_ASM;

    /* Declaration of inports */
    double *inport_alpha_p;
    int16 inport_alpha;
    double *inport_beta_p;
    int16 inport_beta;

    /* *** */
    pTclark_inv_INT16_ASM = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_alpha_p = GetInPortPtrs(block, 1);
    inport_alpha = convert_double_to_Q15(*inport_alpha_p);
    pTclark_inv_INT16_ASM->alpha = &inport_alpha;
    inport_beta_p = GetInPortPtrs(block, 2);
    inport_beta = convert_double_to_Q15(*inport_beta_p);
    pTclark_inv_INT16_ASM->beta = &inport_beta;

    /* Update */
    clark_inv_INT16_ASM_Update(pTclark_inv_INT16_ASM);
}


static void x2c_clark_inv_INT16_ASM_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_clark_inv_INT16_ASM_C__StateUpdate_f(block);
    }
}


static void x2c_clark_inv_INT16_ASM_C__OutputUpdate(scicos_block* block) {
    CLARK_INV_INT16_ASM *pTclark_inv_INT16_ASM;
    CLARK_INV_INT16_ASM tmpclark_inv_INT16_ASM;

    /* Declaration of outports */
    double *outport_a;
    double *outport_b;
    double *outport_c;

    /* *** */
    pTclark_inv_INT16_ASM = GetWorkPtrs(block);

    /* Save work data */
    memcpy(&tmpclark_inv_INT16_ASM, pTclark_inv_INT16_ASM, sizeof(CLARK_INV_INT16_ASM));

    /* *** */
    x2c_clark_inv_INT16_ASM_C__StateUpdate_f(block);

    /* Assignment of outports */
    outport_a = GetOutPortPtrs(block, 1);
    *outport_a = convert_Q15_to_double(pTclark_inv_INT16_ASM->a);
    outport_b = GetOutPortPtrs(block, 2);
    *outport_b = convert_Q15_to_double(pTclark_inv_INT16_ASM->b);
    outport_c = GetOutPortPtrs(block, 3);
    *outport_c = convert_Q15_to_double(pTclark_inv_INT16_ASM->c);

    /* Copy back tmp data */
    memcpy(pTclark_inv_INT16_ASM, &tmpclark_inv_INT16_ASM, sizeof(CLARK_INV_INT16_ASM));
}


