// This file was generated by createCFunction.sci on 26-01-2016 11:59

// Computational function for X2C block park

#define SCILAB_SIM_FILE /* mark this file as Scilab simulation file */

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
#include <Simulation_PortConversion.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <park_INT16_ASM.h>
#include <park_INT16_ASM.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_park_INT16_ASM_C(scicos_block* block, scicos_flag flag);
static void x2c_park_INT16_ASM_C__OutputUpdate(scicos_block* block);
static void x2c_park_INT16_ASM_C__StateUpdate(scicos_block* block);
static void x2c_park_INT16_ASM_C__Initialization(scicos_block* block);
static void x2c_park_INT16_ASM_C__Ending(scicos_block* block);


void x2c_park_INT16_ASM_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_park_INT16_ASM_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_park_INT16_ASM_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_park_INT16_ASM_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_park_INT16_ASM_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_park_INT16_ASM_C__set_parameter(scicos_block* block, PARK_INT16_ASM *blockParam) {
    int *paramI;
    double *paramR;
    PARK_INT16_ASM *pTpark_INT16_ASM;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTpark_INT16_ASM = GetWorkPtrs(block);
}


static void x2c_park_INT16_ASM_C__Initialization(scicos_block* block) {
    PARK_INT16_ASM *pTpark_INT16_ASM;

    /* Declaration of inports */
    double *inport_alpha_p;
    int16 inport_alpha;
    double *inport_beta_p;
    int16 inport_beta;
    double *inport_theta_p;
    int16 inport_theta;

    /* Declaration of outports */
    double *outport_d;
    double *outport_q;

    /* *** */
    pTpark_INT16_ASM = scicos_malloc(sizeof(PARK_INT16_ASM));
    GetWorkPtrs(block) = pTpark_INT16_ASM;
    x2c_park_INT16_ASM_C__set_parameter(block, pTpark_INT16_ASM);

    /* Assignment of inports */
    inport_alpha_p = GetInPortPtrs(block, 1);
    inport_alpha = convert_double_to_Q15(*inport_alpha_p);
    pTpark_INT16_ASM->alpha = &inport_alpha;
    inport_beta_p = GetInPortPtrs(block, 2);
    inport_beta = convert_double_to_Q15(*inport_beta_p);
    pTpark_INT16_ASM->beta = &inport_beta;
    inport_theta_p = GetInPortPtrs(block, 3);
    inport_theta = convert_double_to_Q15(*inport_theta_p);
    pTpark_INT16_ASM->theta = &inport_theta;

    /* Initialization */
    park_INT16_ASM_Init(pTpark_INT16_ASM);

    /* Assignment of outports */
    outport_d = GetOutPortPtrs(block, 1);
    *outport_d = convert_Q15_to_double(pTpark_INT16_ASM->d);
    outport_q = GetOutPortPtrs(block, 2);
    *outport_q = convert_Q15_to_double(pTpark_INT16_ASM->q);
}


static void x2c_park_INT16_ASM_C__Ending(scicos_block* block) {
    PARK_INT16_ASM *pTpark_INT16_ASM;
    pTpark_INT16_ASM = GetWorkPtrs(block);
    scicos_free(pTpark_INT16_ASM);
}


static void x2c_park_INT16_ASM_C__StateUpdate_f(scicos_block* block) {
    PARK_INT16_ASM *pTpark_INT16_ASM;

    /* Declaration of inports */
    double *inport_alpha_p;
    int16 inport_alpha;
    double *inport_beta_p;
    int16 inport_beta;
    double *inport_theta_p;
    int16 inport_theta;

    /* *** */
    pTpark_INT16_ASM = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_alpha_p = GetInPortPtrs(block, 1);
    inport_alpha = convert_double_to_Q15(*inport_alpha_p);
    pTpark_INT16_ASM->alpha = &inport_alpha;
    inport_beta_p = GetInPortPtrs(block, 2);
    inport_beta = convert_double_to_Q15(*inport_beta_p);
    pTpark_INT16_ASM->beta = &inport_beta;
    inport_theta_p = GetInPortPtrs(block, 3);
    inport_theta = convert_double_to_Q15(*inport_theta_p);
    pTpark_INT16_ASM->theta = &inport_theta;

    /* Update */
    park_INT16_ASM_Update(pTpark_INT16_ASM);
}


static void x2c_park_INT16_ASM_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_park_INT16_ASM_C__StateUpdate_f(block);
    }
}


static void x2c_park_INT16_ASM_C__OutputUpdate(scicos_block* block) {
    PARK_INT16_ASM *pTpark_INT16_ASM;
    PARK_INT16_ASM tmppark_INT16_ASM;

    /* Declaration of outports */
    double *outport_d;
    double *outport_q;

    /* *** */
    pTpark_INT16_ASM = GetWorkPtrs(block);

    /* Save work data */
    memcpy(&tmppark_INT16_ASM, pTpark_INT16_ASM, sizeof(PARK_INT16_ASM));

    /* *** */
    x2c_park_INT16_ASM_C__StateUpdate_f(block);

    /* Assignment of outports */
    outport_d = GetOutPortPtrs(block, 1);
    *outport_d = convert_Q15_to_double(pTpark_INT16_ASM->d);
    outport_q = GetOutPortPtrs(block, 2);
    *outport_q = convert_Q15_to_double(pTpark_INT16_ASM->q);

    /* Copy back tmp data */
    memcpy(pTpark_INT16_ASM, &tmppark_INT16_ASM, sizeof(PARK_INT16_ASM));
}


